 		bits 16

FF_TIMEOUT	equ 30

global Game, DoSpecial, InitLev, SetStart
extern ScoreBarDirty, Cheater, msg, playerDead, lives, levelDone, level,maxLev
extern coinsLeft, score, ffR, ffG, ffB, ffY, d20, d50, d250, sndLetr
extern modActive, sndFlag, sndPtr, sndCount, sndDead, sndDsAp, sndSwch, sndLvDn
extern sndCoin, sndGem, snd1Up, levels, player, monsters, monstNum, slimeSpr
extern pacSpr, ballSpr, keys, isKey, isEsc, lastKey, plKeyDown
extern mapData, mapRefresh, tileTable, tilFfRo, tilFfRc, tilSwRo, tilSwRc
extern tilFfGo, tilFfGc, tilSwGo, tilSwGc, tilFfBo, tilFfBc, tilSwBo, tilSwBc
extern tilFfYo, tilFfYc, tilSwYo, tilSwYc
extern dAdd, dInc, dDec, DoSound, ShiftPal, ClearScoreBar, DrawScoreBar, Rand
extern InitScoreBar, SbInit, SbDone, MovePlayer, MoveMonsters, Draw, SndOff

%define _GAME_ASM_
%include "defs.inc"

group dgroup _DATA _BSS

SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( DoSpecial )=------------------------------------------------------------
; -=( Fhrt eine spezielle Aktion durch wenn Obj ein Special-Tile betritt )=-
; -=( IN: ds:si - player, di-TileX, cx-TileY, bx-TileIdx, al-TileNum )=-
; ----------------------------------------------------------------------------
DoSpecial:
	pusha

%macro AddScore 1
	mov di,score
	mov si,%1
	mov bx,6
	call dAdd
	mov byte [ScoreBarDirty],2
%endmacro

	cmp al,TILDSAP		         ;;;Verschwindender Block;;;
	jne .noAppr
	mov byte [mapData+bx],0		;Wird zu Background-Tile
	AddScore d20			;20 Punkte
	mov word [sndPtr],sndDsAp       ;Pc-Speaker-Sound :)
	mov word [sndCount],0
.noAppr:

	cmp al,TILCOIN                  ;;;Mnze;;;
	jne .noCoin
	cmp word [si+objType],0		;Monster knnen nix einsammeln
	jne .noCoin
	xor al,al
	mov [mapData+bx],al		;Mnze wech (BackGround)	
	dec byte [coinsLeft]
	AddScore d50			;50 Punkte
	mov word [sndPtr],sndCoin       ;Sound
	mov word [sndCount],0
.noCoin:

	cmp al,TIL1UP  			;;;1Up;;;
	jne .no1Up
	cmp word [si+objType],0		;Kein Extraleben fr Monster :)
	jne .no1Up
	xor al,al			;1Up wech
	mov [mapData+bx],al
	lea di,[lives]			;Leben dazu
	mov bx,2
	call dInc
	AddScore d250			;250 Punkte
	mov word [sndPtr],snd1Up
	mov word [sndCount],0
.no1Up:

	pusha
	cmp al,TILEXIT	                ;;;Ausgang;;;
	jne .noExit
	cmp word [si+objType],0		;Kein Ausweg fr Monster
	jne .noExit
	cmp byte [coinsLeft],0          ;Nur raus, wenn alle Mnzen gesammelt
	jg .noExit
	cmp byte [curLetr],0		;Nur raus, wenn Buchstaben gesammelt
	jne .noExit
	
	mov ax,[si+objX]
	shr ax,6
	xor dx,dx
	mov cx,TILE_WIDTH
	div cx                          ;ax = tileLeft
	cmp ax,di                       ;Nur raus, wenn genau auf AusgangsTile
	jne .noExit

	mov ax,[si+objX]
	shr ax,6
	mov si,[si+objSpritePtr]
	add ax,[si+sprData]
	dec ax
	xor dx,dx
	div cx                          ;ax = tileRight
	cmp ax,di                       ;Nur raus, wenn genau auf AusgangsTile
	jne .noExit

	mov byte [levelDone],1
	AddScore d250			;500 Punkte
	AddScore d250
	mov word [sndPtr],sndLvDn       ;Sound
	mov word [sndCount],0
	xor al,al
.noExit	popa

	cmp al,TILLADR	                ;;;Leiter;;;
	jne .noLadr
	mov byte [si+objOnLadder],1
.noLadr:

	cmp word [si+objType],1		;Slime kann nicht schalten
	bra e, .noSw

	cmp al,TILSWR	                ;;;Roter Schalter;;;
	jne .noSwR

	cmp word [si+objType],0
	jne .NotPlayerSwR

	push bx
	xor bh,bh
	mov bl,[plKeyDown]
	cmp byte [cs:keys+bx],0
	mov byte [cs:keys+bx],0
	pop bx
	je .noSwR
	jmp short .NotMonsterSwR
.NotPlayerSwR:
	cmp byte [si+objOnSwitch],0
	jne .noSwR
	mov byte [si+objOnSwitch],FF_TIMEOUT
.NotMonsterSwR:

	cmp byte [ffR],0
	jz .setFfR
	
	mov byte [ffR],0
	mov word [tileTable+7*2], tilFfRo
	mov word [tileTable+11*2],tilSwRo
	jmp short .noSetFfR
	
.setFfR mov byte [ffR],1
	mov word [tileTable+7*2], tilFfRc
	mov word [tileTable+11*2],tilSwRc
.noSetFfR:
	jmp .refreshFf                  ;ForceFields refreshen
.noSwR:
	cmp al,TILSWG	                ;;;Gruener Schalter;;;	
	jne .noSwG

	cmp word [si+objType],0
	jne .NotPlayerSwG

	push bx
	xor bh,bh
	mov bl,[plKeyDown]
	cmp byte [cs:keys+bx],0
	mov byte [cs:keys+bx],0
	pop bx
	je .noSwG
	jmp short .NotMonsterSwG
.NotPlayerSwG:
	cmp byte [si+objOnSwitch],0
	jne .noSwG
	mov byte [si+objOnSwitch],FF_TIMEOUT
.NotMonsterSwG:	
	cmp byte [ffG],0
	jz .setFfG
	
	mov byte [ffG],0
	mov word [tileTable+8*2], tilFfGo
	mov word [tileTable+12*2],tilSwGo
	jmp short .noSetFfG
	
.setFfG mov byte [ffG],1
	mov word [tileTable+8*2], tilFfGc
	mov word [tileTable+12*2],tilSwGc
.noSetFfG:
	jmp .refreshFf                  ;ForceFields refreshen
.noSwG:
	
	cmp al,TILSWB 	                ;;;Blauer Schalter;;;
	jne .noSwB      
			
	cmp word [si+objType],0
	jne .NotPlayerSwB

	push bx
	xor bh,bh
	mov bl,[plKeyDown]
	cmp byte [cs:keys+bx],0
	mov byte [cs:keys+bx],0
	pop bx
	je .noSwB
	jmp short .NotMonsterSwB
.NotPlayerSwB:
	cmp byte [si+objOnSwitch],0
	jne .noSwB
	mov byte [si+objOnSwitch],FF_TIMEOUT
.NotMonsterSwB:
	
	cmp byte [ffB],0
	jz .setFfB
	
	mov byte [ffB],0
	mov word [tileTable+9*2], tilFfBo
	mov word [tileTable+13*2],tilSwBo
	jmp .noSetFfR
	
.setFfB mov byte [ffB],1
	mov word [tileTable+9*2], tilFfBc
	mov word [tileTable+13*2],tilSwBc
.noSetFfB:
	jmp .refreshFf                  ;ForceFields refreshen
.noSwB: 
	cmp al,TILSWY	                ;;;Gelber Schalter;;;
	jne .noSwY
	cmp word [si+objType],0		;Nur Player darf gelb umschalten
	jne .noSwY
		
	cmp word [si+objType],0
	jne .NotPlayerSwY

	push bx
	xor bh,bh
	mov bl,[plKeyDown]
	cmp byte [cs:keys+bx],0
	mov byte [cs:keys+bx],0
	pop bx
	je .noSwY
	jmp short .NotMonsterSwY
.NotPlayerSwY:
	cmp byte [si+objOnSwitch],0
	jne .noSwY
	mov byte [si+objOnSwitch],FF_TIMEOUT
.NotMonsterSwY:
	
	cmp byte [ffY],0
	jz .setFfY
	
	mov byte [ffY],0
	mov word [tileTable+10*2],tilFfYo
	mov word [tileTable+14*2],tilSwYo
	jmp short .noSetFfY
	
.setFfY mov byte [ffY],1
	mov word [tileTable+10*2],tilFfYc
	mov word [tileTable+14*2],tilSwYc
.noSetFfY:
	jmp .refreshFf                  ;ForceFields refreshen
.noSwY:
.noSw:
	
	pushx bx,di                     ;;;Force-Fields ;;;
	xor bh,bh
	mov bl,al
	neg bl				;Solid weg
	js $-2
	cmp bl,TILFFY                   ;>ffY?
	ja .noFF                        ;Nein
	cmp bl,TILFFR                   ;<ffR?
	jb .noFF                        ;Nein
	cmp bl,TILFFR
	jne .noFfR
	mov di,ffR
.noFfR  cmp bl,TILFFG
	jne .noFfG
	mov di,ffG
.noFfG  cmp bl,TILFFB
	jne .noFfB
	mov di,ffB
.noFfB  cmp bl,TILFFY
	jne .noFfY
	mov di,ffY
.noFfY:
	cmp byte [di],0
	je .noFF
	mov byte [si+objTrapped],1      ;Vom FF festgehalten
.noFF:  popx di,bx


	cmp al,TILGEM			;;; Diamant ;;;
	jne .noGem
	cmp si,player
	jne .noGem

	xor al,al
	mov byte [mapData+bx],al	;Diamant weg (-> Bg)
	AddScore d250			;250 Punkte
	mov word [sndPtr],sndGem	;Sound
	mov word [sndCount],0
.noGem:

	cmp al,'A'			;;; Buchstabe ;;;
	jb .noLetr
	cmp al,'z'
	ja .noLetr
	cmp al,'Z'
	jbe .IsLetr
	cmp al,'a'
	jb .noLetr
	
.IsLetr	cmp si,player
	jne .noLetr

	xor cl,cl
	mov byte [mapData+bx],cl	;Buchstabe weg
	cmp byte [curLetr],0
	je .Dead
	AddScore d50			;100 Punkte
	AddScore d50
	mov word [sndPtr],sndLetr	;Sound
	mov word [sndCount],0
	cmp byte [curLetr],'A'
	jae .CmpLtr
	cmp al,'a'
	jb .UCase1
	add al,'A'-'a'
.UCase1	mov [curLetr],al
	jmp short .noLetr
.CmpLtr	cmp al,'a'
	jb .UCase2
	add al,'A'-'a'
.UCase2	cmp [curLetr],al
	mov byte [curLetr],0
	je .noLetr			;Richtiger Buchstabe? Fertig.
.Dead	mov byte [playerDead],1		;Falscher? Figur tot :(
.noLetr:

.bye:   popa
	ret
	
.refreshFf:
	mov word [sndPtr],sndSwch       ;Sound
	mov word [sndCount],0

	pushx di,cx,dx
	
	mov ah,al
	sub al,4                        ;Forcefield = Switch - 4
	
	lea di,[mapData]
	xor cx,cx                       ;for(cx=0; cx<MAP_HEIGHT; cx++)
.yLoop: xor dx,dx                       ; for(dx=0; dx<MAP_WIDTH; dx++)
.xLoop: tileIdx dx,cx

	cmp al,[di+bx]                  ;Gesuchtes ForceField?
	je .setRf
	cmp ah,[di+bx]                  ;Gesuchter Schalter?
	jne .notRightOne
.setRf  mov byte [mapRefresh+bx],3      ;Refresh-Flag setzen
.notRightOne:
	
	inc dx
	cmp dx,MAP_WIDTH
	jb .xLoop

	inc cx
	cmp cx,MAP_HEIGHT
	jb .yLoop

	popx dx,cx,di
	popa
	ret
		
; -=( InitLev )=------------------------------------------------------------
; -=( Kopiert Level x nach mapData, fllt mapRefresh mit 4en, setzt Actor
;     auf Starttile (falls vorhanden), zhlt die Mnzen, initted Monster )=-
; -=( IN: [ds:level] - LevelNr )=-
; --------------------------------------------------------------------------
InitLev:
	pusha
	push es

	push ds
	pop es

	xor ax,ax
	mov [letrNum],al
	mov [levelDone],al
	mov di,letrPos
	mov cx,26
	rep stosw
	mov cx,13
	rep stosw
	lea si,[player]
	mov [si+objX],ax
	mov [si+objY],ax

	;Level nach mapData kopieren
	lea si,[levels]
	mov ax,MAP_SIZE                 ;Level indexen
	xor dh,dh
	mov dl,[level]
	mul dx
	add si,ax

	lea di,[mapData]

	mov cx,MAP_SIZE                 ;Kopieren
	rep movsb

	;mapRefresh mit 4en fllen 
	lea di,[mapRefresh]
	mov cx,MAP_SIZE
	mov al,4
	rep stosb

	mov al,1
	mov byte [ffR],al               ;ForceFields resetten
	mov word [tileTable+14],tilFfRc
	mov word [tileTable+22],tilSwRc
	mov byte [ffG],al
	mov word [tileTable+16],tilFfGc
	mov word [tileTable+24],tilSwGc
	mov byte [ffB],al
	mov word [tileTable+18],tilFfBc
	mov word [tileTable+26],tilSwBc
	mov byte [ffY],al
	mov word [tileTable+20],tilFfYc
	mov word [tileTable+28],tilSwYc

	mov byte [coinsLeft],0

	;MonsterArray mit 0en fllen
	lea di,[monsters]
	mov cx,MAX_MONSTERS * obj_size
	xor al,al
	rep stosb

	mov byte [playerDead],0
	mov word [monstNum],0

	mov bp,monsters

	;Starttile suchen

	lea di,[mapData]
	xor cx,cx                       ;for(cx=0; cx<MAP_HEIGHT; cx++)
.yLoop: xor dx,dx                       ; for(dx=0; dx<MAP_WIDTH; dx++)
.xLoop: tileIdx dx,cx
	mov al,[di+bx]

	cmp	al,TILLETR		;Buchstabenfeld?
	jne	.noLetr
	cmp	b[letrNum],26
	jb	.Letter
	mov	b[di+bx],0		;Wenn mehr als 26 -> Hintergrundfeld
	jmp	short .noLetr
.Letter	push	si,ax
	mov	al,[letrNum]
	xor	ah,ah
	shl	ax,1
	add	ax,letrPos
	mov	si,ax
	mov	[si],bx			;Position sichern
	pop	ax,si
	inc	b[letrNum]		;Zhlen

.noLetr	cmp al,TILMAN
	jne .noPlStrt
	mov si,player
	call SetStart                   ;Playerposition setzen
.noPlStrt:


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
%macro MonsterStart 5
	cmp al,%1		         ;Starttile fr Monster?
	jnz %%noMStrt

	cmp word [monstNum],MAX_MONSTERS ;Wenn max. Monsteranzahl erreicht
	jae %%noMStrt 			 ;  kein Monster mehr generieren
	inc word [monstNum]

	mov si,bp
	add bp,obj_size

	mov word [si+objType],%2         ;Initialisieren
	mov word [si+objSpritePtr],%3
	mov word [si+objSpeedX],%4
	mov word [si+objSpeedFall],%5

	call SetStart                   ;Position setzen
%%noMStrt:
%endmacro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	;  Monster:  TileNr, Num, Sprite,  speedX, speedFall
        ;            ------- ---  -------- ------  ---------
	MonsterStart TILSLIM, 1,  slimeSpr, 64/4,  1		;Slime
	MonsterStart TILPAC,  2,  pacSpr,   48,    0		;PacMonster
	MonsterStart TILBALL, 3,  ballSpr,  128,   0		;Ball

	cmp al,TILCOIN	                ;Mnze?
	jnz .noCoin
	inc byte [coinsLeft]            ;Zhlen

.noCoin	neg	al			;Solid wech
	js	$-2

	cmp	al,TILLAST		;Ungltiges Tile?
	jna	.TileOk
	
	mov	b[di+bx],0		; wird zu Hintergrundtile!

.TileOk	inc dx
	cmp dx,MAP_WIDTH	
	brab .xLoop

	inc cx
	cmp cx,MAP_HEIGHT
	brab .yLoop

.bye	pop es
	popa
	ret

; -=( InitLetr )=-----------------------------------------------------------
; -=( Weist allen Buchstabenfeldern Buchstaben zu )=-
; --------------------------------------------------------------------------
InitLetr:
	pusha

	mov si,mapData
	xor ch,ch
	mov cl,[letrNum]
	cmp cx,1
	je .Bye

.Next	dec cx
	js .Bye
	jz .Ultr

.NewLtr	call Rand
	xor ah,ah
	mov bl,26
	div bl
	xor bh,bh
	mov bl,ah
	cmp byte [letrUse+bx],0
	jne .NewLtr
	mov byte [letrUse+bx],1
	add ah,'a'
	
.Assign	mov bx,cx
	shl bx,1
	mov bx,[letrPos+bx]
	mov [mapData+bx],ah
	jmp short .Next

.Ultr	call Rand
	xor ah,ah
	mov bl,26
	div bl
	xor bh,bh
	mov bl,ah
	cmp byte [letrUse+bx],0
	je .Ultr
	add ah,'A'
	jmp short .Assign

.Bye	popa
	ret

; -=( ShowLev )=------------------------------------------------------------
; -=( Zeigt einen Level an, setzt ScoreBar auf "Level: xx" und wartet )=-
; -=( auf Tastendruck )=-
; --------------------------------------------------------------------------
ShowLev	pusha
	push es

	push ds
	pop es

	mov dx,[lives]			;Leben sichern
	mov bx,[score+0]		;Punkte sichern
	mov cx,[score+2]
	mov si,[score+4]

	call ClearScoreBar
	pusha
	MemCpy msg,"Level:"
	popa

	mov al,[level]			;Level in Msg setzen
	xor ah,ah
	push bx
	mov bl,10
	div bl
	pop bx
	or ax,'00'
	mov [lives],ax

	mov byte [cs:Color],94
	mov byte [ScoreBarDirty],2	;Level anzeigen
	call Draw
	call Draw
	mov byte [cs:Color],155

	mov byte [cs:isKey],0
.KeyLp	cmp byte [cs:isKey],0
	je .KeyLp

	call InitScoreBar
	mov byte [ScoreBarDirty],2

	mov [lives],dx			;Lives wieder einsetzen
	mov [score+0],bx		;Score   "        "
	mov [score+2],cx
	mov [score+4],si

	pop es
	popa
	ret

; -=( SetStart )=-----------------------------------------------------------
; -=( Setzt die Position eines objs durch seine TilePosition fest )=-
; -=( IN: cx - tileY, dx - tileX, si - obj )=-
; --------------------------------------------------------------------------
SetStart:
	pushx ax,dx

	;x festlegen (tilex*tw * 64)
	mov ax,TILE_WIDTH
	mul dx
	shl ax,6
	mov [si+objX],ax

	;y festlegen (tiley*th * 64)
	mov ax,TILE_HEIGHT
	mul cx
	shl ax,6
	mov [si+objY],ax

	;Gravity resetten
	mov word [si+objGravity],0
	
	popx dx,ax
	ret
	
; -=( Game )=---------------------------------------------------------------
; --------------------------------------------------------------------------
Game:	cmp byte [modActive],0
	je .NoPlayMod

	call SbInit
	call ClearScreen
	call FlipPage
	call ClearScreen
	
	mov byte [ScoreBarDirty],2

.NoPlayMod:

	call InitLev
	call InitLetr
	call ShowLev

MainLoop:
	cmp byte [Cheater],0		;Cheat aktivert?
	je .NoCheater
	pusha
	MemCpy score,"Cheater!",0
	popa
	mov byte [cs:Color],94
.NoCheater:

	cmp byte [cs:isEsc],0           ;ESC gedrckt?
	bra ne, EscPressed              ;GameOver

	cmp byte [cs:keys+KEY_P],0	;P gedrckt?
	bra ne, Pause			;Pause

	cmp byte [playerDead],0         ;Spieler tot?
	jnz CheckLives                  ;Leben abziehen / GameOver bei 0 Leben

	cmp byte [levelDone],0          ;Level geschafft?
	bra ne, NextLevel               ;Nchster Level / GameOver nach maxLev

	cmp byte [cs:keys+KEY_L],0	;L-A-M-E gedrckt?
	je .NoCheat
	cmp byte [cs:keys+KEY_A],0
	je .NoCheat
	cmp byte [cs:keys+KEY_M],0
	je .NoCheat
	cmp byte [cs:keys+KEY_E],0
	je .NoCheat
	jmp Cheat
.NoCheat:

	call Draw
	call MovePlayer
	call MoveMonsters

	jmp short MainLoop

CheckLives:
	mov word [sndPtr],sndDead
	mov word [sndCount],0

	pushx ax,bx

	mov al,[modActive]
	mov byte [modActive],0

.SndLp: call Draw                       ;U.a. Sound abspielen
	mov bx,[sndPtr]                 ;Auf SoundEnde warten
	cmp byte [sndFlag],0
	je .SndDone
	cmp word [bx],0
	jne .SndLp
.SndDone:

	mov [modActive],al
	popx bx,ax

	pushx di,bx
	mov di,lives
	mov bx,2
	call dDec			;Leben abziehen
	mov byte [ScoreBarDirty],2
	popx bx,di
	bra c, GameOver                 ;Weniger als 0 Leben -> GameOver
	mov byte [playerDead],0         ;Sonst wieder zum Leben erwecken...
	call InitLev                    ;...Level neu initialisieren...
	call InitLetr
	call ShowLev

	jmp MainLoop              	;...wieder ins Spiel!!!

NextLevel:
	pushx ax,bx

	mov al,[modActive]
	mov byte [modActive],0

.SndLp: call Draw	                ;U.a. Sound abspielen
	mov bx,[sndPtr]                 ;Auf SoundEnde warten
	cmp byte [sndFlag],0
	je .SndDone
	cmp word [bx],0
	jne .SndLp
.SndDone:

	mov [modActive],al

	mov al,[level]
	inc al                          ;Nchster Level
	mov [level],al
	cmp al,[maxLev]                 ;Alle Level geschafft?
	popx bx,ax
	ja AllDone                      ;Raus
	call InitLev                    ;Sonst Level neu initialisieren...
	call InitLetr
	call ShowLev

	jmp MainLoop              	;...wieder ins Spiel!!!

Pause:
	mov byte [cs:isKey],0
.ChkKey	cmp byte [cs:isKey],0		;Auf Taste prfen
	je .ChkKey
	jmp MainLoop			;zurck!

Cheat:	mov word [lives],'42'		;42 Leben
	mov byte [ScoreBarDirty],2
	mov byte [Cheater],1
	jmp MainLoop

EscPressed:
AllDone:
GameOver:
	mov byte [cs:isEsc],0           ;Fr Editor

	cmp byte [modActive],0
	je .NoSbDone

	call SbDone

.NoSbDone:

	ret

SEGMENT _BSS ALIGN=2 CLASS=BSS
letrPos	resw 26
letrUse resb 26
letrNum resb 1
curLetr equ letrNum
