		bits 16

%define _MAIN_ASM_
%include "defs.inc"

extern levels, maxLev, level, score, lives, msg, keys, fnt, romFnt, pal
extern playerSpr, slimeSpr, pacSpr, ballSpr, SbIrq, SbAddr, MixSpeed
extern ErrorInfo, ErrorMod, ModFile, ProgSize, modActive, lastKey, gameHelp
extern title1,title2,title3,title4,title5, ver, menu1,menu2,menu3,menu4,menu5
extern LoadModule, FreeModule, SbPoll, SndOff, InstallKB, RemoveKB,DispHelp
extern InitLev,Game,DrawScoreBar,ClearScoreBar,Editor,InitScoreBar,PrintError
extern MovePlayer, MoveMonsters, SRand, DoPyro, _DetectSb, PromptFilename
extern DefaultLcn, DefaultLcnErr

GROUP DGROUP _BSS _DATA
SEGMENT _TEXT PUBLIC ALIGN=2 CLASS=CODE

; -=( Init )=---------------------------------------------------------------
; -=( Initialisiert Graphik, Keyboard, Timer; ndert Palette; 
;     ermittelt Gre der Frames und Faces jedes Sprites )=-
; -=( OUT: DS - Data Segment )=-
; --------------------------------------------------------------------------
Init:	
	pushx si,ax,bx,dx

	call InstallKB
	call InitGraph
	call SRand
	
	mov ax,[cs:FontPtr]
	mov [romFnt],ax
	mov ax,[cs:FontPtr+2]
	mov [romFnt+2],ax

	mov word [cs:FontPtr],fnt
	mov word [cs:FontPtr+2],seg fnt

	;Palette festlegen
	lea si,[pal]
	call SetPal

	jmp short .Cont

.CalcSiz:  ;IN: si = Sprite
	pushx di,ax,bx,dx

	lea di,[si+sprData]
	mov ax,[di]			;ax = width
	mov bx,[di+2]			;bx = height
	mul bx				;ax = w*h
	add ax,2*2			;2 words fr width und height
	mov [si+sprFrameSize],ax	;Gre speichern

	mov bx,[si+sprNoOfFrames]
	mul bx				;ax = FaceSize = FrameSize*NoOfFrames
	mov [si+sprFaceSize],ax		;Speichern

	popx dx,bx,ax,di
	ret
.Cont:
	lea si,[playerSpr]
	call .CalcSiz
	lea si,[slimeSpr]
	call .CalcSiz
	lea si,[pacSpr]
	call .CalcSiz
	lea si,[ballSpr]
	call .CalcSiz

	popx dx,bx,ax,si
	ret


; -=( Prolog )=-------------------------------------------------------------
Prolog:	pusha

	mov byte [cs:Color],136		;Copyright
	call DrawScoreBar

	mov byte [cs:Color],117		;Titel
	mov cx,50
	mov dx,15
	mov si,title1
	call OutStr
	add dx,8
	mov si,title2
	call OutStr
	add dx,8
	mov si,title3
	call OutStr
	add dx,8
	mov si,title4
	call OutStr
	add dx,8
	mov si,title5
	call OutStr

	mov byte [cs:Color],90		;Version
	add dx,15
	mov cx,130
	mov si,ver
	call OutStr

	mov byte [cs:Color],30		;Menu
	mov cx,8
	add dx,50
	mov si,menu1
	call OutStr
	add dx,12
	mov byte [cs:Color],22
	mov si,menu2
	call OutStr
	add dx,12
	mov byte [cs:Color],15
	mov si,menu3
	call OutStr
	mov cx,200
	sub dx,2*12
	mov byte [cs:Color],15
	mov si,menu4
	call OutStr
	add dx,12
	mov byte [cs:Color],22
	mov si,menu5
	call OutStr
	
	
	call FlipPage

	popa
	ret
		
; -=( Epilog )=-------------------------------------------------------------
Epilog: ret

; -=( Exit )=---------------------------------------------------------------
; -=( Setzt TextMode, entfernt Keyboard- und Timerhandler )=-
; --------------------------------------------------------------------------
Exit: ;	call CleanUpTimer
	call SndOff
	call RemoveKB
	
	mov ax,3			;Mode 3 - 16-Color TextMode (CGA+)
	int 10h				;Bios Video

	cmp byte [modActive],0
	je .DontFreeMod	
	
        call FreeModule              ; Free MODule core.
.DontFreeMod:

	ret

; -=( Main )=---------------------------------------------------------------
; --------------------------------------------------------------------------
..start:
Main:	
	mov ax,_DATA			;ds initialisieren
	mov ds,ax
	
	mov dx,es

        mov bx,ss		    	;Shrinks my Memory Block
        add bx,400h >> 4           	;to get more core for
        sub bx,dx                   	;the MODule data.
        inc bx

        mov ax,4A00h                	;Shrink!
        int 21h
        
        mov	ah,fOpen		;Default-Lcn laden...
        xor	al,al
	mov	dx,DefaultLcn
	int	21h
	bra	c,Begin			;... falls vorhanden

	mov	bx,ax			;MaxLev einlesen
	mov	ah,fRead
	mov	dx,maxLev
	mov	cx,2
	int	21h
	cmp	ax,cx
	jne	DLErr
	cmp	w[maxLev],20		;max. 20 Levels
	jb	Ok

DLErr	mov	ah,9
	mov	dx,DefaultLcnErr
	int	21h
	mov	ax,4c01h
	int	21h

Ok	mov	ax,[maxLev]		;Levels einlesen
	inc	ax
	mov	cx,390
	mul	cx
	mov	cx,ax
	mov	ah,fRead
	mov	dx,levels
	int	21h
	cmp	ax,cx
	jne	DLErr
	
	mov	ah,fClose
	int	21h

Begin	mov bx,80h			;PSP CmdLine Length
	mov al,[es:bx]
	or al,al			;Parameter?
	jz ModActive			;Wenn nicht, MOD vorbereiten
	mov byte [modActive],0		;Sonst keine Musik
ModActive:

	cmp byte [modActive],0
	je DontLoadMod

	call _DetectSb
	cmp word [SbIrq],0
	jne LoadMod

	mov byte [modActive],0
	jmp short DontLoadMod
	
LoadMod push ds
	push word ModFile
	call LoadModule			;Load the MODule...

        cmp word [ErrorInfo],0      	;Any error loading?
        je PlayNow

ErrMod  mov ah,9                	;Yes, print error and Exit.
        lea dx,[ErrorMod]
        int 21h
	mov ax,4c01h
	int 21h

PlayNow:
DontLoadMod:


	mov bp,0xffff
	call Init
.KAgain	call SndOff
	call Prolog
	call Prolog
	call DoPyro
	mov byte [cs:Color],155

	mov al,[cs:lastKey]		;Taste abfragen
	cmp al,KEY_S			;S = Spiel
	mov byte [cs:keys+KEY_S],0
	je .Normal
	cmp al,KEY_E			;E = Editor
	mov byte [cs:keys+KEY_E],0
	je .Editor
	cmp al,KEY_Q			;Q = Quit
	bra e, .Quit
;	cmp al,KEY_L			;L = Load Levelfile
;	je .LoadLev	
	cmp al,KEY_H			;H = Hilfe
	bra e, .Help

	jmp short .KAgain		;Nochmal Taste abfragen

.Editor	call ClearScreen
	call FlipPage
	call ClearScreen
	call InitScoreBar
	call Editor			;Editor aufrufen
	call Epilog
	jmp .Quit			;Raus

.Normal call InitScoreBar
	mov word [lives],'09'		;9 Leben
	call Game			;Game aufrufen
	call Epilog
.GameOver:
	call ClearScreen
	call FlipPage
	call ClearScreen
	MemCpy msg,"Game Over..."
	mov byte [level],0
	jmp .KAgain			;Titelbild

.LoadLev:
	inc bp
	call PromptFilename		;Nach Datei fragen
	dec bp
	
	mov al,2			;Leveldatei laden
	mov ah,fOpen
	mov dx,msg
	int 21h
	jc .Err

	mov	di,[maxLev]
	mov	bx,ax			;MaxLev einlesen
	mov	ah,fRead
	mov	dx,maxLev
	mov	cx,2
	int	21h
	jc	.Err
	cmp	w[maxLev],20		;max. 20 Levels
	xchg	di,[maxLev]
	jae	.Err
	xchg	di,[maxLev]

	push bx				;levels einlesen
	mov ax,[maxLev]
	inc ax
	mov cx,390
	mul cx
	pop bx
	mov cx,ax
	mov ah,fRead
	mov dx,levels
	int 21h
	jc .Err

	call ClearScoreBar	
	jmp .KAgain
	
.Err:	call PrintError			;"Error!" anzeigen
	jmp .KAgain
	
.Help:	mov si,gameHelp
	call DispHelp
	jmp .KAgain
	

.Quit	call Exit
	mov ax,4c00h
	int 21h
	
SEGMENT _DATA
SEGMENT _BSS CLASS=BSS
SEGMENT STACK STACK CLASS=STACK
resb 400h
